package fr.mael.jiwigo;

import java.io.File;
import java.io.IOException;
import javax.swing.UIManager;
import com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel;
import fr.mael.jiwigo.transverse.session.SessionManager;
import fr.mael.jiwigo.transverse.util.Outil;
import fr.mael.jiwigo.transverse.util.preferences.PreferencesManagement;
import fr.mael.jiwigo.ui.ConnexionDialog;
import fr.mael.jiwigo.ui.mainframe.MainFrame;


/**
   Copyright (c) 2010, Mael
   All rights reserved.

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright
      notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright
      notice, this list of conditions and the following disclaimer in the
      documentation and/or other materials provided with the distribution.
    * Neither the name of jiwigo nor the
      names of its contributors may be used to endorse or promote products
      derived from this software without specific prior written permission.

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL Mael BE LIABLE FOR ANY
   DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
   ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
   
 * Classe principale de lancement de l'interface.
 * @author mael
 *
 */
public class Main {

	/**
	 * Logger
	 */
	public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory.getLog(Main.class);
	/**
	 * The login and session manager that allows to connect to
	 * the webservice and to query it
	 */
	public static SessionManager sessionManager;

	/**
	 *  the main window
	 */
	private static MainFrame mainFrame;


	public static void main(String[] args) {
		try {
			UIManager.setLookAndFeel(new NimbusLookAndFeel());
		} catch (Exception e) {
		}
		File dossierConfig = new File(System.getProperty("user.home") + "/.jiwigo");
		if (!dossierConfig.exists()) {
			dossierConfig.mkdir();
		}
		try {
			PreferencesManagement.creerFichierParDefaut();
			//dialog de connexion
			ConnexionDialog dialog = new ConnexionDialog();
			dialog.showDialog();
		} catch (IOException e) {
			LOG.error(Outil.getStackTrace(e));
		}

	}


	public static void showFrame() {

		if (mainFrame == null) {
			mainFrame = MainFrame.getInstance();
		}
		if (!mainFrame.isVisible()) {
			mainFrame.showUi();
		}
	}
}
